﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TextBoxValidationRule
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window
    {
        Student stu = new Student() { Name = "张三", Age = 20 };
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = stu;
        }
        private void btnSubmit_Click(object sender, RoutedEventArgs e)
        {
            // 方法一
            if (!Validation.GetHasError(txtName) && !Validation.GetHasError(txtAge))
            {
                MessageBox.Show("Verificate successfully.");
            }
            else
            {
                MessageBox.Show("Please input correct data in red textbox", "Warning", MessageBoxButton.OK, MessageBoxImage.Warning);
            }

            // 方法二
            // Submit();
        }
        private void Submit()
        {
            List<TextBox> texboxs = new List<TextBox>();
            GetChildrenObject(this, ref texboxs, true);
            foreach (var texbox in texboxs)
            {
                if (Validation.GetHasError(texbox))
                {
                    MessageBox.Show("Please input correct data in red textbox", "Warning", MessageBoxButton.OK, MessageBoxImage.Warning);
                    return;
                }
            }
            MessageBox.Show("Verificate successfully.");
        }
        private void GetChildrenObject<T>(DependencyObject obj, ref List<T> list, bool isDeepSearch) where T : FrameworkElement
        {
            DependencyObject child = null;
            for (var i = 0; i <= VisualTreeHelper.GetChildrenCount(obj) - 1; i++)
            {
                child = VisualTreeHelper.GetChild(obj, i);

                if (child is T)
                {
                    list.Add((T)child);
                }
                else
                {
                    if (isDeepSearch)
                    {
                        GetChildrenObject(child, ref list, true);
                    }
                }
            }
        }
    }
}
