﻿using System.Globalization;
using System.Windows.Controls;

namespace TextBoxValidationRule
{
    class StringRule : ValidationRule
    {
        public string ErrorMessage { get; set; }
        public int MinLength { get; set; }
        public int MaxLength { get; set; }
        public override ValidationResult Validate(object value, CultureInfo cultureInfo)
        {
            if (value == null || string.IsNullOrEmpty(value.ToString()))
            {
                return new ValidationResult(false, "Invalid word format");
            }
            int length = value.ToString().Trim().Length;

            if (length > MaxLength || length < MinLength)
            {
                if (!string.IsNullOrEmpty(ErrorMessage))
                {
                    return new ValidationResult(false, ErrorMessage);
                }
                else
                {
                    return new ValidationResult(false, string.Format("The length of words should between {0} and {1}", MinLength, MaxLength));
                }
            }
            return ValidationResult.ValidResult;
        }
    }
}
